

;;;SWIG wrapper code starts here

(cl:defmacro defanonenum (&body enums)
   "Converts anonymous enums to defconstants."
  `(cl:progn ,@(cl:loop for value in enums
                        for index = 0 then (cl:1+ index)
                        when (cl:listp value) do (cl:setf index (cl:second value)
                                                          value (cl:first value))
                        collect `(cl:defconstant ,value ,index))))

(cl:eval-when (:compile-toplevel :load-toplevel)
  (cl:unless (cl:fboundp 'swig-lispify)
    (cl:defun swig-lispify (name flag cl:&optional (package cl:*package*))
      (cl:labels ((helper (lst last rest cl:&aux (c (cl:car lst)))
                    (cl:cond
                      ((cl:null lst)
                       rest)
                      ((cl:upper-case-p c)
                       (helper (cl:cdr lst) 'upper
                               (cl:case last
                                 ((lower digit) (cl:list* c #\- rest))
                                 (cl:t (cl:cons c rest)))))
                      ((cl:lower-case-p c)
                       (helper (cl:cdr lst) 'lower (cl:cons (cl:char-upcase c) rest)))
                      ((cl:digit-char-p c)
                       (helper (cl:cdr lst) 'digit 
                               (cl:case last
                                 ((upper lower) (cl:list* c #\- rest))
                                 (cl:t (cl:cons c rest)))))
                      ((cl:char-equal c #\_)
                       (helper (cl:cdr lst) '_ (cl:cons #\- rest)))
                      (cl:t
                       (cl:error "Invalid character: ~A" c)))))
        (cl:let ((fix (cl:case flag
                        ((constant enumvalue) "+")
                        (variable "*")
                        (cl:t ""))))
          (cl:intern
           (cl:concatenate
            'cl:string
            fix
            (cl:nreverse (helper (cl:concatenate 'cl:list name) cl:nil cl:nil))
            fix)
           package))))))

;;;SWIG wrapper code ends here


(cl:defconstant ATTR_a "Execution_Time")

(cl:defconstant ATTR_c "Checkpoint")

(cl:defconstant ATTR_e "Error_Path")

(cl:defconstant ATTR_g "group_list")

(cl:defconstant ATTR_h "Hold_Types")

;; (cl:defconstant ATTR_j "Join_Path")

(cl:defconstant ATTR_J "array_indices_submitted")

(cl:defconstant ATTR_k "Keep_Files")

(cl:defconstant ATTR_l "Resource_List")

(cl:defconstant ATTR_m "Mail_Points")

(cl:defconstant ATTR_o "Output_Path")

(cl:defconstant ATTR_p "Priority")

(cl:defconstant ATTR_q "destination")

(cl:defconstant ATTR_r "Rerunable")

(cl:defconstant ATTR_u "User_List")

(cl:defconstant ATTR_v "Variable_List")

;;(cl:defconstant ATTR_A "Account_Name")

;; (cl:defconstant ATTR_M "Mail_Users")

(cl:defconstant ATTR_N "Job_Name")

(cl:defconstant ATTR_S "Shell_Path_List")

(cl:defconstant ATTR_array_indices_submitted "array_indices_submitted")

(cl:defconstant ATTR_depend "depend")

(cl:defconstant ATTR_inter "interactive")

(cl:defconstant ATTR_jobdir_enable "job_dir_enable")

(cl:defconstant ATTR_stagein "stagein")

(cl:defconstant ATTR_stageout "stageout")

(cl:defconstant ATTR_resvTag "reserve_Tag")

(cl:defconstant ATTR_resvID "reserve_ID")

(cl:defconstant ATTR_resv_start "reserve_start")

(cl:defconstant ATTR_resv_end "reserve_end")

(cl:defconstant ATTR_resv_duration "reserve_duration")

(cl:defconstant ATTR_resv_state "reserve_state")

(cl:defconstant ATTR_resv_substate "reserve_substate")

(cl:defconstant ATTR_auth_u "Authorized_Users")

(cl:defconstant ATTR_auth_g "Authorized_Groups")

(cl:defconstant ATTR_auth_h "Authorized_Hosts")

(cl:defconstant ATTR_pwd "pwd")

(cl:defconstant ATTR_cred "cred")

(cl:defconstant ATTR_nodemux "no_stdio_sockets")

(cl:defconstant ATTR_umask "umask")

(cl:defconstant ATTR_block "block")

(cl:defconstant ATTR_convert "qmove")

(cl:defconstant ATTR_DefaultChunk "default_chunk")

(cl:defconstant ATTR_ctime "ctime")

(cl:defconstant ATTR_exechost "exec_host")

(cl:defconstant ATTR_execvnode "exec_vnode")

(cl:defconstant ATTR_resv_nodes "resv_nodes")

(cl:defconstant ATTR_mtime "mtime")

(cl:defconstant ATTR_qtime "qtime")

(cl:defconstant ATTR_session "session_id")

(cl:defconstant ATTR_jobdir "job_dir")

(cl:defconstant ATTR_euser "euser")

(cl:defconstant ATTR_egroup "egroup")

(cl:defconstant ATTR_hashname "hashname")

(cl:defconstant ATTR_hopcount "hop_count")

(cl:defconstant ATTR_security "security")

(cl:defconstant ATTR_sched_hint "sched_hint")

(cl:defconstant ATTR_SchedSelect "schedselect")

(cl:defconstant ATTR_substate "substate")

(cl:defconstant ATTR_name "Job_Name")

(cl:defconstant ATTR_owner "Job_Owner")

(cl:defconstant ATTR_used "resources_used")

(cl:defconstant ATTR_state "job_state")

(cl:defconstant ATTR_queue "queue")

(cl:defconstant ATTR_server "server")

(cl:defconstant ATTR_maxrun "max_running")

(cl:defconstant ATTR_total "total_jobs")

(cl:defconstant ATTR_comment "comment")

(cl:defconstant ATTR_cookie "cookie")

(cl:defconstant ATTR_qrank "queue_rank")

(cl:defconstant ATTR_altid "alt_id")

(cl:defconstant ATTR_altid2 "alt_id2")

(cl:defconstant ATTR_acct_id "accounting_id")

(cl:defconstant ATTR_array "array")

(cl:defconstant ATTR_array_id "array_id")

(cl:defconstant ATTR_array_index "array_index")

(cl:defconstant ATTR_array_state_count "array_state_count")

(cl:defconstant ATTR_array_indices_remaining "array_indices_remaining")

(cl:defconstant ATTR_etime "etime")

(cl:defconstant ATTR_gridname "gridname")

(cl:defconstant ATTR_refresh "last_context_refresh")

(cl:defconstant ATTR_ReqCredEnable "require_cred_enable")

(cl:defconstant ATTR_ReqCred "require_cred")

(cl:defconstant ATTR_runcount "run_count")

(cl:defconstant ATTR_stime "stime")

(cl:defconstant ATTR_pset "pset")

(cl:defconstant ATTR_version "pbs_version")

(cl:defconstant ATTR_eligible_time "eligible_time")

(cl:defconstant ATTR_accrue_type "accrue_type")

(cl:defconstant ATTR_sample_starttime "sample_starttime")

(cl:defconstant ATTR_resv_name "Reserve_Name")

(cl:defconstant ATTR_resv_owner "Reserve_Owner")

(cl:defconstant ATTR_resv_type "reserve_type")

(cl:defconstant ATTR_resv_Tag "reservation_Tag")

(cl:defconstant ATTR_resv_ID "reserve_ID")

(cl:defconstant ATTR_aclgren "acl_group_enable")

(cl:defconstant ATTR_aclgroup "acl_groups")

(cl:defconstant ATTR_aclhten "acl_host_enable")

(cl:defconstant ATTR_aclhost "acl_hosts")

(cl:defconstant ATTR_acluren "acl_user_enable")

(cl:defconstant ATTR_acluser "acl_users")

(cl:defconstant ATTR_altrouter "alt_router")

(cl:defconstant ATTR_chkptmin "checkpoint_min")

(cl:defconstant ATTR_enable "enabled")

(cl:defconstant ATTR_fromroute "from_route_only")

(cl:defconstant ATTR_HasNodes "hasnodes")

(cl:defconstant ATTR_killdelay "kill_delay")

(cl:defconstant ATTR_maxgrprun "max_group_run")

(cl:defconstant ATTR_maxgrprunsoft "max_group_run_soft")

(cl:defconstant ATTR_maxque "max_queuable")

(cl:defconstant ATTR_maxuserrun "max_user_run")

(cl:defconstant ATTR_maxuserrunsoft "max_user_run_soft")

(cl:defconstant ATTR_qtype "queue_type")

(cl:defconstant ATTR_rescassn "resources_assigned")

(cl:defconstant ATTR_rescdflt "resources_default")

(cl:defconstant ATTR_rescmax "resources_max")

(cl:defconstant ATTR_rescmin "resources_min")

(cl:defconstant ATTR_rndzretry "rendezvous_retry")

(cl:defconstant ATTR_routedest "route_destinations")

(cl:defconstant ATTR_routeheld "route_held_jobs")

(cl:defconstant ATTR_routewait "route_waiting_jobs")

(cl:defconstant ATTR_routeretry "route_retry_time")

(cl:defconstant ATTR_routelife "route_lifetime")

(cl:defconstant ATTR_rsvexpdt "reserved_expedite")

(cl:defconstant ATTR_rsvsync "reserved_sync")

(cl:defconstant ATTR_start "started")

(cl:defconstant ATTR_count "state_count")

(cl:defconstant ATTR_number "number_jobs")

(cl:defconstant ATTR_SvrHost "server_host")

(cl:defconstant ATTR_aclroot "acl_roots")

(cl:defconstant ATTR_managers "managers")

(cl:defconstant ATTR_dfltque "default_queue")

(cl:defconstant ATTR_defnode "default_node")

(cl:defconstant ATTR_locsvrs "location_servers")

(cl:defconstant ATTR_logevents "log_events")

(cl:defconstant ATTR_logfile "log_file")

(cl:defconstant ATTR_mailfrom "mail_from")

(cl:defconstant ATTR_nodepack "node_pack")

(cl:defconstant ATTR_nodefailrq "node_fail_requeue")

(cl:defconstant ATTR_operators "operators")

(cl:defconstant ATTR_queryother "query_other_jobs")

(cl:defconstant ATTR_resccost "resources_cost")

(cl:defconstant ATTR_rescavail "resources_available")

(cl:defconstant ATTR_maxuserres "max_user_res")

(cl:defconstant ATTR_maxuserressoft "max_user_res_soft")

(cl:defconstant ATTR_maxgroupres "max_group_res")

(cl:defconstant ATTR_maxgroupressoft "max_group_res_soft")

(cl:defconstant ATTR_maxarraysize "max_array_size")

(cl:defconstant ATTR_PNames "pnames")

(cl:defconstant ATTR_schedit "scheduler_iteration")

(cl:defconstant ATTR_scheduling "scheduling")

(cl:defconstant ATTR_status "server_state")

(cl:defconstant ATTR_syscost "system_cost")

(cl:defconstant ATTR_FlatUID "flatuid")

(cl:defconstant ATTR_FLicenses "FLicenses")

(cl:defconstant ATTR_ResvEnable "resv_enable")

(cl:defconstant ATTR_aclResvgren "acl_resv_group_enable")

(cl:defconstant ATTR_aclResvgroup "acl_resv_groups")

(cl:defconstant ATTR_aclResvhten "acl_resv_host_enable")

(cl:defconstant ATTR_aclResvhost "acl_resv_hosts")

(cl:defconstant ATTR_aclResvuren "acl_resv_user_enable")

(cl:defconstant ATTR_aclResvuser "acl_resv_users")

(cl:defconstant ATTR_NodeGroupEnable "node_group_enable")

(cl:defconstant ATTR_NodeGroupKey "node_group_key")

(cl:defconstant ATTR_ssignon_enable "single_signon_password_enable")

(cl:defconstant ATTR_dfltqdelargs "default_qdel_arguments")

(cl:defconstant ATTR_dfltqsubargs "default_qsub_arguments")

(cl:defconstant ATTR_rpp_retry "rpp_retry")

(cl:defconstant ATTR_rpp_highwater "rpp_highwater")

(cl:defconstant ATTR_license_location "pbs_license_file_location")

(cl:defconstant ATTR_license_min "pbs_license_min")

(cl:defconstant ATTR_license_max "pbs_license_max")

(cl:defconstant ATTR_license_linger "pbs_license_linger_time")

(cl:defconstant ATTR_license_count "license_count")

(cl:defconstant ATTR_job_sort_formula "job_sort_formula")

(cl:defconstant ATTR_current_sampletime "current_sampletime")

(cl:defconstant ATTR_EligibleTimeEnable "eligible_time_enable")

(cl:defconstant ATTR_SchedHost "sched_host")

(cl:defconstant ATTR_NODE_Host "Host")

(cl:defconstant ATTR_NODE_Mom "Mom")

(cl:defconstant ATTR_NODE_Port "Port")

(cl:defconstant ATTR_NODE_state "state")

(cl:defconstant ATTR_NODE_ntype "ntype")

(cl:defconstant ATTR_NODE_jobs "jobs")

(cl:defconstant ATTR_NODE_resvs "resv")

(cl:defconstant ATTR_NODE_resv_enable "resv_enable")

(cl:defconstant ATTR_NODE_np "np")

(cl:defconstant ATTR_NODE_pcpus "pcpus")

(cl:defconstant ATTR_NODE_properties "properties")

(cl:defconstant ATTR_NODE_NoMultiNode "no_multinode_jobs")

(cl:defconstant ATTR_NODE_No_Tasks "no_tasks")

(cl:defconstant ATTR_NODE_Sharing "sharing")

(cl:defconstant ATTR_RESC_TYPE "type")

(cl:defconstant ATTR_RESC_FLAG "flag")

(cl:defconstant CHECKPOINT_UNSPECIFIED "u")

(cl:defconstant NO_HOLD "n")

(cl:defconstant NO_JOIN "n")

(cl:defconstant NO_KEEP "n")

(cl:defconstant MAIL_AT_ABORT "a")

(cl:defconstant DELDELAY "deldelay=")

(cl:defconstant USER_HOLD "u")

(cl:defconstant OTHER_HOLD "o")

(cl:defconstant SYSTEM_HOLD "s")

(cl:defconstant BAD_PASSWORD_HOLD "p")

(cl:defconstant ND_free "free")

(cl:defconstant ND_offline "offline")

(cl:defconstant ND_down "down")

(cl:defconstant ND_Stale "Stale")

(cl:defconstant ND_jobbusy "job busy")

(cl:defconstant ND_job_exclusive "job exclusive")

(cl:defconstant ND_job_sharing "job sharing")

(cl:defconstant ND_busy "busy")

(cl:defconstant ND_state_unknown "state unknown")

(cl:defconstant ND_pbs "PBS")

(cl:defconstant ND_globus "globus")

(cl:defconstant ND_Default_Shared "default_shared")

(cl:defconstant ND_Default_Excl "default_excl")

(cl:defconstant ND_Ignore_Excl "ignore_excl")

(cl:defconstant ND_Force_Excl "force_excl")

(cl:defconstant ND_Initializing "initializing")

(cl:defconstant MAX_ENCODE_BFR 100)

(cl:defconstant MGR_CMD_CREATE 0)

(cl:defconstant MGR_CMD_DELETE 1)

(cl:defconstant MGR_CMD_SET 2)

(cl:defconstant MGR_CMD_UNSET 3)

(cl:defconstant MGR_CMD_LIST 4)

(cl:defconstant MGR_CMD_PRINT 5)

(cl:defconstant MGR_CMD_ACTIVE 6)

(cl:defconstant MGR_OBJ_NONE -1)

(cl:defconstant MGR_OBJ_SERVER 0)

(cl:defconstant MGR_OBJ_QUEUE 1)

(cl:defconstant MGR_OBJ_JOB 2)

(cl:defconstant MGR_OBJ_NODE 3)

(cl:defconstant MGR_OBJ_RESV 4)

(cl:defconstant MGR_OBJ_RSC 5)

(cl:defconstant MGR_OBJ_SCHED 6)

(cl:defconstant MGR_OBJ_HOST 7)

(cl:defconstant ATR_TYPE_LONG 1)

(cl:defconstant ATR_TYPE_CHAR 2)

(cl:defconstant ATR_TYPE_STR 3)

(cl:defconstant ATR_TYPE_ARST 4)

(cl:defconstant ATR_TYPE_SIZE 5)

(cl:defconstant ATR_TYPE_RESC 6)

(cl:defconstant ATR_TYPE_LIST 7)

(cl:defconstant ATR_TYPE_ACL 8)

(cl:defconstant ATR_TYPE_LL 9)

(cl:defconstant ATR_TYPE_SHORT 10)

(cl:defconstant ATR_TYPE_BOOL 11)

(cl:defconstant ATR_TYPE_JINFOP 13)

(cl:defconstant ATR_TYPE_FLOAT 14)

(cl:defconstant ATR_DFLAG_USRD #x01)

(cl:defconstant ATR_DFLAG_USWR #x02)

(cl:defconstant ATR_DFLAG_OPRD #x04)

(cl:defconstant ATR_DFLAG_OPWR #x08)

(cl:defconstant ATR_DFLAG_MGRD #x10)

(cl:defconstant ATR_DFLAG_MGWR #x20)

(cl:defconstant ATR_DFLAG_OTHRD #x40)

(cl:defconstant ATR_DFLAG_Creat #x80)

(cl:defconstant ATR_DFLAG_SvRD #x100)

(cl:defconstant ATR_DFLAG_SvWR #x200)

(cl:defconstant ATR_DFLAG_MOM #x400)

(cl:defconstant ATR_DFLAG_RDACC #x515)

(cl:defconstant ATR_DFLAG_WRACC #x6AA)

(cl:defconstant ATR_DFLAG_ACCESS #x7ff)

(cl:defconstant ATR_DFLAG_ALTRUN #x0800)

(cl:defconstant ATR_DFLAG_NOSAVM #x1000)

(cl:defconstant ATR_DFLAG_SELEQ #x2000)

(cl:defconstant ATR_DFLAG_RASSN #x4000)

(cl:defconstant ATR_DFLAG_ANASSN #x8000)

(cl:defconstant ATR_DFLAG_FNASSN #x10000)

(cl:defconstant ATR_DFLAG_CVTSLT #x20000)

(cl:defconstant ATR_TRUE "True")

(cl:defconstant ATR_FALSE "False")

(cl:defconstant MSG_OUT 1)

(cl:defconstant MSG_ERR 2)

(cl:defconstant SHUT_MASK #xf)

(cl:defconstant SHUT_WHO_MASK #x1f0)

(cl:defconstant SHUT_IMMEDIATE 0)

(cl:defconstant SHUT_DELAY 1)

(cl:defconstant SHUT_QUICK 2)

(cl:defconstant SHUT_SIG 8)

(cl:defconstant SHUT_WHO_SCHED #x10)

(cl:defconstant SHUT_WHO_MOM #x20)

(cl:defconstant SHUT_WHO_SECDRY #x40)

(cl:defconstant SHUT_WHO_IDLESECDRY #x80)

(cl:defconstant SHUT_WHO_SECDONLY #x100)

(cl:defconstant SIG_RESUME "resume")

(cl:defconstant SIG_SUSPEND "suspend")

(cl:defconstant SIG_TermJob "TermJob")

(cl:defconstant SIG_RERUN "Rerun")

(cl:defconstant PLACE_Group "group")

(cl:defconstant PLACE_Excl "excl")

(cl:defconstant PLACE_Shared "shared")

(cl:defconstant PLACE_Free "free")

(cl:defconstant PLACE_Pack "pack")

(cl:defconstant PLACE_Scatter "scatter")

(cl:defconstant BLUEGENE "bluegene")

(cl:defconstant PBS_MAXHOSTNAME 64)

(cl:defconstant MAXPATHLEN 1024)

(cl:defconstant MAXNAMLEN 255)

(cl:defconstant PBS_MAXUSER 16)

(cl:defconstant PBS_MAXGRPN 16)

(cl:defconstant PBS_MAXQUEUENAME 15)

(cl:defconstant PBS_MAXJOBNAME 15)

(cl:defconstant PBS_MAXSERVERNAME 64)

(cl:defconstant PBS_MAXSEQNUM 7)

(cl:defconstant PBS_MAXPORTNUM 5)

(cl:defconstant PBS_MAXSVRJOBID (cl:+ (cl:- 7 1) 64 5 2))

(cl:defconstant PBS_MAXSVRRESVID (cl:+ 7 1 64 5 2))

(cl:defconstant PBS_MAXQRESVNAME 15)

(cl:defconstant PBS_MAXCLTJOBID (cl:+ (cl:- 7 1) 64 5 2 64 5 2))

(cl:defconstant PBS_MAXDEST 256)

(cl:defconstant PBS_MAXROUTEDEST (cl:+ 15 64 5 2))

(cl:defconstant PBS_USE_IFF 1)

(cl:defconstant PBS_INTERACTIVE 1)

(cl:defconstant PBS_TERM_BUF_SZ 80)

(cl:defconstant PBS_TERM_CCA 6)

(cl:defconstant PBS_RESV_ID_CHAR #\\)

;; (cl:defconstant PBS_RESV_FUTURE_SCH 1893488460L)

(cl:defconstant PBS_BATCH_SERVICE_NAME "pbs")

(cl:defconstant PBS_BATCH_SERVICE_PORT 15001)

(cl:defconstant PBS_BATCH_SERVICE_NAME_DIS "pbs_dis")

(cl:defconstant PBS_BATCH_SERVICE_PORT_DIS 15001)

(cl:defconstant PBS_MOM_SERVICE_NAME "pbs_mom")

(cl:defconstant PBS_MOM_SERVICE_PORT 15002)

(cl:defconstant PBS_MANAGER_SERVICE_NAME "pbs_resmon")

(cl:defconstant PBS_MANAGER_SERVICE_PORT 15003)

(cl:defconstant PBS_SCHEDULER_SERVICE_NAME "pbs_sched")

(cl:defconstant PBS_SCHEDULER_SERVICE_PORT 15004)

(cl:defconstant PBS_MOM_GLOBUS_SERVICE_NAME "pbs_mom_globus")

(cl:defconstant PBS_MOM_GLOBUS_SERVICE_PORT 15005)

(cl:defconstant PBS_MANAGER_GLOBUS_SERVICE_NAME "pbs_resmon_globus")

(cl:defconstant PBS_MANAGER_GLOBUS_SERVICE_PORT 15006)

(cffi:defcenum batch_op
	:SET
	:UNSET
	:INCR
	:DECR
	:EQ
	:NE
	:GE
	:GT
	:LE
	:LT
	:DFLT)

(cffi:defcstruct attrl
	(next :pointer)
	(name :string)
	(resource :string)
	(value :string)
	(op batch_op))

(cffi:defcstruct attropl
	(next :pointer)
	(name :string)
	(resource :string)
	(value :string)
	(op batch_op))

(cffi:defcstruct batch_status
	(next :pointer)
	(name :string)
	(attribs :pointer)
	(text :string))

(cffi:defcstruct pbs_config
	(loaded :unsigned-int)
	(load_failed :unsigned-int)
	(start_server :unsigned-int)
	(start_mom :unsigned-int)
	(start_sched :unsigned-int)
	(locallog :unsigned-int)
	(syslogfac :unsigned-int)
	(syslogsvr :unsigned-int)
	(batch_service_port :unsigned-int)
	(batch_service_port_dis :unsigned-int)
	(mom_service_port :unsigned-int)
	(manager_service_port :unsigned-int)
	(scheduler_service_port :unsigned-int)
	(mom_globus_service_port :unsigned-int)
	(manager_globus_service_port :unsigned-int)
	(pbs_conf_file :string)
	(pbs_home_path :string)
	(pbs_exec_path :string)
	(pbs_server_name :string)
	(scp_path :string)
	(rcp_path :string)
	(pbs_demux_path :string)
	(pbs_environment :string)
	(iff_path :string)
	(k5dcelogin_path :string)
	(pbs_primary :string)
	(pbs_secondary :string)
	(pbs_mom_home :string)
	(pbs_core_limit :string))

(cffi:defcvar ("pbs_conf" pbs_conf)
 pbs_config)

(cl:defconstant PBS_CONF_START_SERVER "PBS_START_SERVER")

(cl:defconstant PBS_CONF_START_MOM "PBS_START_MOM")

(cl:defconstant PBS_CONF_START_SCHED "PBS_START_SCHED")

(cl:defconstant PBS_CONF_LOCALLOG "PBS_LOCALLOG")

(cl:defconstant PBS_CONF_SYSLOG "PBS_SYSLOG")

(cl:defconstant PBS_CONF_SYSLOGSEVR "PBS_SYSLOGSEVR")

(cl:defconstant PBS_CONF_BATCH_SERVICE_PORT "PBS_BATCH_SERVICE_PORT")

(cl:defconstant PBS_CONF_BATCH_SERVICE_PORT_DIS "PBS_BATCH_SERVICE_PORT_DIS")

(cl:defconstant PBS_CONF_MOM_SERVICE_PORT "PBS_MOM_SERVICE_PORT")

(cl:defconstant PBS_CONF_MANAGER_SERVICE_PORT "PBS_MANAGER_SERVICE_PORT")

(cl:defconstant PBS_CONF_SCHEDULER_SERVICE_PORT "PBS_SCHEDULER_SERVICE_PORT")

(cl:defconstant PBS_CONF_MOM_GLOBUS_SERVICE_PORT "PBS_MOM_GLOBUS_SERVICE_PORT")

(cl:defconstant PBS_CONF_MANAGER_GLOBUS_SERVICE_PORT "PBS_MANAGER_GLOBUS_SERVICE_PORT")

(cl:defconstant PBS_CONF_HOME "PBS_HOME")

(cl:defconstant PBS_CONF_EXEC "PBS_EXEC")

(cl:defconstant PBS_CONF_DEFAULT_NAME "PBS_DEFAULT")

(cl:defconstant PBS_CONF_SERVER_NAME "PBS_SERVER")

(cl:defconstant PBS_CONF_RCP "PBS_RCP")

(cl:defconstant PBS_CONF_SCP "PBS_SCP")

(cl:defconstant PBS_CONF_ENVIRONMENT "PBS_ENVIRONMENT")

(cl:defconstant PBS_CONF_K5DCELOGIN "PBS_K5DCELOGIN")

(cl:defconstant PBS_CONF_PRIMARY "PBS_PRIMARY")

(cl:defconstant PBS_CONF_SECONDARY "PBS_SECONDARY")

(cl:defconstant PBS_CONF_MOM_HOME "PBS_MOM_HOME")

(cl:defconstant PBS_CONF_CORE_LIMIT "PBS_CORE_LIMIT")

(cffi:defcenum accrue_types
	(:JOB_NEW 0)
	:JOB_INELIGIBLE
	:JOB_ELIGIBLE
	:JOB_RUNNING
	:JOB_EXIT
	:JOB_UNKN)

(cl:defconstant ACCRUE_NEW "0")

(cl:defconstant ACCRUE_INEL "1")

(cl:defconstant ACCRUE_ELIG "2")

(cl:defconstant ACCRUE_RUNN "3")

(cl:defconstant ACCRUE_EXIT "4")

(cl:defconstant ACCRUE_UNKN "5")

(cffi:defcenum resv_states
	:RESV_NONE
	:RESV_UNCONFIRMED
	:RESV_CONFIRMED
	:RESV_WAIT
	:RESV_TIME_TO_RUN
	:RESV_RUNNING
	:RESV_FINISHED
	:RESV_BEING_DELETED
	:RESV_DELETED
	:RESV_DELETING_JOBS)

(cffi:defcvar ("pbs_errno" pbs_errno)
 :int)

(cffi:defcvar ("pbs_server" pbs_server)
 :string)

(cffi:defcfun ("avail" avail) :string
  (connect :int)
  (resc :string))

(cffi:defcfun ("pbs_asyrunjob" pbs_asyrunjob) :int
  (c :int)
  (jobid :string)
  (location :string)
  (extend :string))

(cffi:defcfun ("pbs_alterjob" pbs_alterjob) :int
  (connect :int)
  (job_id :string)
  (attrib :pointer)
  (extend :string))

(cffi:defcfun ("pbs_connect" pbs_connect) :int
  (server :string))

(cffi:defcfun ("pbs_connect_noblk" pbs_connect_noblk) :int
  (server :string)
  (to :int))

(cffi:defcfun ("pbs_query_max_connections" pbs_query_max_connections) :int)

(cffi:defcfun ("pbs_default" pbs_default) :string)

(cffi:defcfun ("pbs_deljob" pbs_deljob) :int
  (connect :int)
  (job_id :string)
  (extend :string))

(cffi:defcfun ("pbs_disconnect" pbs_disconnect) :int
  (connect :int))

(cffi:defcfun ("pbs_geterrmsg" pbs_geterrmsg) :string
  (connect :int))

(cffi:defcfun ("pbs_holdjob" pbs_holdjob) :int
  (connect :int)
  (job_id :string)
  (hold_type :string)
  (extend :string))

(cffi:defcfun ("pbs_locjob" pbs_locjob) :string
  (connect :int)
  (job_id :string)
  (extend :string))

(cffi:defcfun ("pbs_manager" pbs_manager) :int
  (connect :int)
  (command :int)
  (obj_type :int)
  (obj_name :string)
  (attrib :pointer)
  (extend :string))

(cffi:defcfun ("pbs_movejob" pbs_movejob) :int
  (connect :int)
  (job_id :string)
  (destination :string)
  (extend :string))

(cffi:defcfun ("pbs_msgjob" pbs_msgjob) :int
  (connect :int)
  (job_id :string)
  (file :int)
  (message :string)
  (extend :string))

(cffi:defcfun ("pbs_orderjob" pbs_orderjob) :int
  (connect :int)
  (job1 :string)
  (job2 :string)
  (extend :string))

(cffi:defcfun ("pbs_rescquery" pbs_rescquery) :int
  (connect :int)
  (rlist :pointer)
  (nresc :int)
  (avail :pointer)
  (alloc :pointer)
  (resv :pointer)
  (down :pointer))

(cffi:defcfun ("pbs_rescreserve" pbs_rescreserve) :int
  (connect :int)
  (rlist :pointer)
  (nresc :int)
  (phandle :pointer))

(cffi:defcfun ("pbs_rescrelease" pbs_rescrelease) :int
  (connect :int)
  (rhandle :int))

(cffi:defcfun ("pbs_rerunjob" pbs_rerunjob) :int
  (connect :int)
  (job_id :string)
  (extend :string))

(cffi:defcfun ("pbs_rlsjob" pbs_rlsjob) :int
  (connect :int)
  (job_id :string)
  (hold_type :string)
  (extend :string))

(cffi:defcfun ("pbs_runjob" pbs_runjob) :int
  (connect :int)
  (jobid :string)
  (loc :string)
  (extend :string))

(cffi:defcfun ("pbs_selectjob" pbs_selectjob) :pointer
  (connect :int)
  (select_list :pointer)
  (extend :string))

(cffi:defcfun ("pbs_sigjob" pbs_sigjob) :int
  (connect :int)
  (job_id :string)
  (signal :string)
  (extend :string))

(cffi:defcfun ("pbs_statfree" pbs_statfree) :void
  (stat :pointer))

(cffi:defcfun ("pbs_statdest" pbs_statdest) :pointer
  (connect :int)
  (id :string)
  (extend :string))

(cffi:defcfun ("pbs_statjob" pbs_statjob) :pointer
  (connect :int)
  (id :string)
  (attrib :pointer)
  (extend :string))

(cffi:defcfun ("pbs_selstat" pbs_selstat) :pointer
  (connect :int)
  (select_list :pointer)
  (attrib :pointer)
  (extend :string))

(cffi:defcfun ("pbs_statrsc" pbs_statrsc) :pointer
  (connect :int)
  (id :string)
  (attrib :pointer)
  (extend :string))

(cffi:defcfun ("pbs_statque" pbs_statque) :pointer
  (connect :int)
  (id :string)
  (attrib :pointer)
  (extend :string))

(cffi:defcfun ("pbs_statserver" pbs_statserver) :pointer
  (connect :int)
  (attrib :pointer)
  (extend :string))

(cffi:defcfun ("pbs_statsched" pbs_statsched) :pointer
  (connect :int)
  (attrib :pointer)
  (extend :string))

(cffi:defcfun ("pbs_stathost" pbs_stathost) :pointer
  (connect :int)
  (id :string)
  (attrib :pointer)
  (extend :string))

(cffi:defcfun ("pbs_statnode" pbs_statnode) :pointer
  (connect :int)
  (id :string)
  (attrib :pointer)
  (extend :string))

(cffi:defcfun ("pbs_statvnode" pbs_statvnode) :pointer
  (connect :int)
  (id :string)
  (attrib :pointer)
  (extend :string))

(cffi:defcfun ("pbs_statresv" pbs_statresv) :pointer
  (connect :int)
  (id :string)
  (attrib :pointer)
  (extend :string))

(cffi:defcfun ("pbs_submit" pbs_submit) :string
  (connect :int)
  (attrib :pointer)
  (script :string)
  (destination :string)
  (extend :string))

(cffi:defcfun ("pbs_submit_resv" pbs_submit_resv) :string
  (connection :int)
  (attrib :pointer)
  (extend :string))

(cffi:defcfun ("pbs_delresv" pbs_delresv) :int
  (connect :int)
  (resv_id :string)
  (extend :string))

(cffi:defcfun ("pbs_terminate" pbs_terminate) :int
  (connect :int)
  (manner :int)
  (extend :string))

(cffi:defcfun ("totpool" totpool) :int
  (connect :int)
  (update :int))

(cffi:defcfun ("usepool" usepool) :int
  (connect :int)
  (update :int))

(cffi:defcfun ("pbs_loadconf" pbs_loadconf) :int
  (reload :int))

(cffi:defcfun ("pbs_popen" pbs_popen) :pointer
  (command :string)
  (type :string))

(cffi:defcfun ("pbs_pkill" pbs_pkill) :int
  (iop :pointer)
  (sig :int))

(cffi:defcfun ("pbs_pclose" pbs_pclose) :int
  (iop :pointer))

(cffi:defcfun ("pbs_strsep" pbs_strsep) :string
  (stringp :pointer)
  (delim :string))

(cffi:defcfun ("pbs_confirmresv" pbs_confirmresv) :int
  (connect :int)
  (rid :string)
  (allocate :string)
  (start :unsigned-long)
  (extend :string))

(cffi:defcfun ("pbs_defschreply" pbs_defschreply) :int
  (con :int)
  (cmd :int)
  (id :string)
  (err :int)
  (txt :string)
  (extend :string))

(cffi:defcfun ("pbs_quote_parse" pbs_quote_parse) :int
  (in :string)
  (out :pointer)
  (endptr :pointer))

(cffi:defcfun ("pbs_parse_err_msg" pbs_parse_err_msg) :string
  (err :int))

(cffi:defcfun ("pbs_prt_parse_err" pbs_prt_parse_err) :void
  (txt :string)
  (str :string)
  (offset :int)
  (err :int))


